Consolidate ODL SFC RPM into ODL RPM
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16
17   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
18     if [ "${deploy_options_array['sdn_l3']}" == 'True' ]; then
19       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_l3.yaml"
20     elif [ "${deploy_options_array['sfc']}" == 'True' ]; then
21       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
22     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
23       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
24     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
25       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_fdio.yaml"
26     elif [ "${deploy_options_array['vpn']}" == 'true' ]; then
27       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sdnvpn.yaml"
28     else
29       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight.yaml"
30     fi
31     SDN_IMAGE=opendaylight
32   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
33     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
34     SDN_IMAGE=opendaylight
35   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
36     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
37       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
38     else
39       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
40     fi
41     SDN_IMAGE=onos
42   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
43     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
44     exit 1
45   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
46     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
47     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
48       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-networking-vpp.yaml"
49     fi
50     SDN_IMAGE=opendaylight
51   else
52     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
53     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
54     exit 1
55   fi
56
57
58
59   # Make sure the correct overcloud image is available
60   if [ ! -f $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
61       echo "${red} $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
62       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
63       exit 1
64   fi
65
66   echo "Copying overcloud image to Undercloud"
67   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
68   scp ${SSH_OPTIONS[@]} $RESOURCES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
69
70   # Install ovs-dpdk inside the overcloud image if it is enabled.
71   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
72     # install dpdk packages before ovs
73     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
74
75     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
76       cat << EOF > vfio_pci.modules
77 #!/bin/bash
78 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
79 EOF
80
81       cat << EOF > uio_pci_generic.modules
82 #!/bin/bash
83 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
84 EOF
85
86       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
87                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
88                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
89                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
90                                                -a overcloud-full.qcow2
91
92       if [ "${deploy_options_array['dataplane']}" == 'fdio' ]; then
93         sudo sed -i '/FdioEnabled:/c\  FdioEnabled: true' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
94         LIBGUESTFS_BACKEND=direct virt-customize --run-command "cp -f /root/fdio_neutron_l3/namespaces.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
95                                                  --run-command "cp -f /root/fdio_neutron_l3/router_info.py /usr/lib/python2.7/site-packages/neutron/agent/l3/" \
96                                                  -a overcloud-full.qcow2
97         if [ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]; then
98           LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /root/ && tar zxvf networking-odl.tar.gz" \
99                                                    --run-command "cd /root/networking-odl && git init && pip install -r requirements.txt" \
100                                                    --run-command "cd /root/networking-odl && python setup.py build && python setup.py install" \
101                                                    -a overcloud-full.qcow2
102         fi
103       else
104         sudo sed -i '/NeutronOVSDataPathType:/c\  NeutronOVSDataPathType: netdev' /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
105         LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/dpdk_rpms/*" \
106                                                  --run-command "sed -i '/RuntimeDirectoryMode=.*/d' /usr/lib/systemd/system/openvswitch-nonetwork.service" \
107                                                  --run-command "printf \"%s\\n\" RuntimeDirectoryMode=0775 Group=qemu UMask=0002 >> /usr/lib/systemd/system/openvswitch-nonetwork.service" \
108                                                  --run-command "sed -i 's/\\(^\\s\\+\\)\\(start_daemon "$OVS_VSWITCHD_PRIORITY"\\)/\\1umask 0002 \\&\\& \\2/' /usr/share/openvswitch/scripts/ovs-ctl" \
109                                                  -a overcloud-full.qcow2
110       fi
111
112       if [ "${deploy_options_array['sfc']}" == 'True' ]; then
113           # upgrade ovs into ovs 2.5.90 with NSH function
114           LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
115                                                    --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
116                                                    -a overcloud-full.qcow2
117       fi
118 EOI
119
120   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
121     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
122     exit 1
123   fi
124
125   if [ "$debug" == 'TRUE' ]; then
126     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
127   fi
128
129   # Set ODL version accordingly
130   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['odl_version']}" == 'boron' ]]; then
131     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
132       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
133                                                --run-command "yum -y install /root/boron/*" \
134                                                -a overcloud-full.qcow2
135 EOI
136   fi
137
138   # Add performance deploy options if they have been set
139   if [ ! -z "${deploy_options_array['performance']}" ]; then
140
141     # Remove previous kernel args files per role
142     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Compute-kernel_params.txt"
143     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f Controller-kernel_params.txt"
144
145     # Push performance options to subscript to modify per-role images as needed
146     for option in "${performance_options[@]}" ; do
147       echo -e "${blue}Setting performance option $option${reset}"
148       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "dataplane=${deploy_options_array['dataplane']} bash build_perf_image.sh $option"
149     done
150
151     # Build IPA kernel option ramdisks
152     ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" <<EOI
153 /bin/cp -f /home/stack/ironic-python-agent.initramfs /root/
154 mkdir -p ipa/
155 pushd ipa
156 gunzip -c ../ironic-python-agent.initramfs | cpio -i
157 if [ ! -f /home/stack/Compute-kernel_params.txt ]; then
158   touch /home/stack/Compute-kernel_params.txt
159   chown stack /home/stack/Compute-kernel_params.txt
160 fi
161 /bin/cp -f /home/stack/Compute-kernel_params.txt tmp/kernel_params.txt
162 echo "Compute params set: "
163 cat tmp/kernel_params.txt
164 /bin/cp -f /root/image.py usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.py
165 /bin/cp -f /root/image.pyc usr/lib/python2.7/site-packages/ironic_python_agent/extensions/image.pyc
166 find . | cpio -o -H newc | gzip > /home/stack/Compute-ironic-python-agent.initramfs
167 chown stack /home/stack/Compute-ironic-python-agent.initramfs
168 if [ ! -f /home/stack/Controller-kernel_params.txt ]; then
169   touch /home/stack/Controller-kernel_params.txt
170   chown stack /home/stack/Controller-kernel_params.txt
171 fi
172 /bin/cp -f /home/stack/Controller-kernel_params.txt tmp/kernel_params.txt
173 echo "Controller params set: "
174 cat tmp/kernel_params.txt
175 find . | cpio -o -H newc | gzip > /home/stack/Controller-ironic-python-agent.initramfs
176 chown stack /home/stack/Controller-ironic-python-agent.initramfs
177 popd
178 /bin/rm -rf ipa/
179 EOI
180
181     # set NIC heat params and resource registry
182     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
183 if [ -n "${private_network_compute_interface}" ]; then
184   sudo sed -i '/ComputeTenantNIC:/c\  ComputeTenantNIC: '${private_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
185 fi
186 if [ -n "${private_network_controller_interface}" ]; then
187   sudo sed -i '/ControllerTenantNIC:/c\  ControllerTenantNIC: '${private_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
188 fi
189 # TODO: PublicNIC is not used today, however, in the future, we'll bind public nic to DPDK as well for certain scenarios. At that time,
190 # we'll need to make sure public network is enabled.
191 if [ -n "${public_network_compute_interface}" ]; then
192   sudo sed -i '/ComputePublicNIC:/c\  ComputePublicNIC: '${public_network_compute_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
193 fi
194 if [ -n "${public_network_controller_interface}" ]; then
195   sudo sed -i '/ControllerPublicNIC:/c\  ControllerPublicNIC: '${public_network_controller_interface} /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml
196 fi
197 EOI
198
199     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/numa.yaml"
200   fi
201
202   # make sure ceph is installed
203   DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
204
205   #DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/network-isolation.yaml"
206   DEPLOY_OPTIONS+=" -e network-environment.yaml"
207
208
209   # get number of nodes available in inventory
210   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
211   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
212
213   # check if HA is enabled
214   if [[ "$ha_enabled" == "True" ]]; then
215     if [ "$num_control_nodes" -lt 3 ]; then
216       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
217       exit 1
218     else
219      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
220      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
221      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
222     fi
223   else
224     if [ "$num_control_nodes" -lt 1 ]; then
225       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
226       exit 1
227     fi
228   fi
229
230   if [ "$num_compute_nodes" -le 0 ]; then
231     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
232     exit 1
233   else
234     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
235     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
236   fi
237
238   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
239
240   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
241   if [[ "$virtual" == "TRUE" ]]; then
242      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
243   fi
244
245   DEPLOY_OPTIONS+=" -e opnfv-environment.yaml"
246
247   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
248
249   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
250 if [ "${deploy_options_array['tacker']}" == 'False' ]; then
251     sed -i '/EnableTacker:/c\  EnableTacker: false' opnfv-environment.yaml
252 fi
253
254 # Create a key for use by nova for live migration
255 echo "Creating nova SSH key for nova resize support"
256 ssh-keygen -f nova_id_rsa -b 1024 -P ""
257 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
258 sed -i "s#replace_public_key:#key: \$public_key#g" opnfv-environment.yaml
259 python -c 'open("opnfv-environment-new.yaml", "w").write((open("opnfv-environment.yaml").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
260 mv -f opnfv-environment-new.yaml opnfv-environment.yaml
261
262 source stackrc
263 set -o errexit
264 # Workaround for APEX-207 where sometimes swift proxy is down
265 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
266   sudo systemctl restart openstack-swift-proxy
267 fi
268 echo "Uploading overcloud glance images"
269 openstack overcloud image upload
270
271 echo "Configuring undercloud and discovering nodes"
272 openstack baremetal import --json instackenv.json
273 openstack baremetal configure boot
274 bash -x set_perf_images.sh ${performance_roles[@]}
275 #if [[ -z "$virtual" ]]; then
276 #  openstack baremetal introspection bulk start
277 #fi
278 echo "Configuring flavors"
279 for flavor in baremetal control compute; do
280   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
281   if openstack flavor list | grep \${flavor}; then
282     openstack flavor delete \${flavor}
283   fi
284   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
285   if ! openstack flavor list | grep \${flavor}; then
286     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
287   fi
288 done
289 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
290 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
291 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
292 echo "Configuring nameserver on ctlplane network"
293 dns_server_ext=''
294 for dns_server in ${dns_servers}; do
295   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
296 done
297 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
298 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} opnfv-environment.yaml
299 echo "Executing overcloud deployment, this should run for an extended period without output."
300 sleep 60 #wait for Hypervisor stats to check-in to nova
301 # save deploy command so it can be used for debugging
302 cat > deploy_command << EOF
303 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
304 EOF
305 EOI
306
307   if [ "$interactive" == "TRUE" ]; then
308     if ! prompt_user "Overcloud Deployment"; then
309       echo -e "${blue}INFO: User requests exit${reset}"
310       exit 0
311     fi
312   fi
313
314   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
315 source stackrc
316 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
317 if ! heat stack-list | grep CREATE_COMPLETE 1>/dev/null; then
318   $(typeset -f debug_stack)
319   debug_stack
320   exit 1
321 fi
322 EOI
323
324   # Configure DPDK
325   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
326     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
327 source stackrc
328 set -o errexit
329 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
330 echo "Running DPDK test app on \$node"
331 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
332 set -o errexit
333 sudo dpdk_helloworld --no-pci
334 sudo dpdk_nic_bind -s
335 EOF
336 done
337 EOI
338   fi
339
340   if [ "$debug" == 'TRUE' ]; then
341       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
342 source overcloudrc
343 echo "Keystone Endpoint List:"
344 openstack endpoint list
345 echo "Keystone Service List"
346 openstack service list
347 cinder quota-show \$(openstack project list | grep admin | awk {'print \$2'})
348 EOI
349   fi
350 }